package se.su.dsv.scipro.date;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@Entity
@Table(name = "settings_date")
@Data
@EqualsAndHashCode(of = "style", callSuper = false)
@SuppressWarnings("PMD.UnusedPrivateField")
public class DateSetting extends DomainObject {

    @Id
    @Enumerated(EnumType.STRING)
    @Column(name = "style", nullable = false)
    private DateStyle style;

    @Basic
    @Column(name = "format", nullable = false)
    private String format = "yyyy-MM-dd";

    public DateSetting() {
    }

    @Override
    public Long getId() {
        return (long) style.ordinal();
    }
}
