package se.su.dsv.scipro.notifications;

import se.su.dsv.scipro.finalseminar.FinalSeminar;
import se.su.dsv.scipro.group.Group;
import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.milestones.dataobjects.Milestone;
import se.su.dsv.scipro.notifications.dataobject.*;
import se.su.dsv.scipro.peer.PeerRequest;
import se.su.dsv.scipro.peer.PeerReview;
import se.su.dsv.scipro.project.Project;

import java.util.Set;

public interface NotificationController {

    Set<Notification> notifyGroup(final Group group, final GroupEvent.Event event, final NotificationSource source); //TODO change to some group event?

    void notifyProject(final Project project, final ProjectEvent.Event event, final NotificationSource source);

    Set<Notification> notifyProjectForum(final ProjectForumEvent.Event event, final NotificationSource source, Project project);

    void notifySeminar(final FinalSeminar seminar, final SeminarEvent.Event event, final NotificationSource source);

    void notifyPeer(final PeerReview review, final PeerEvent.Event event, final NotificationSource source);

    void notifyPeer(final PeerRequest request, final PeerEvent.Event event, final NotificationSource source);

    void notifyIdea(final Idea idea, final IdeaEvent.Event event, final NotificationSource source);

    void notifyMileStone(final Milestone milestone, MileStoneEvent.Event event, final NotificationSource source);
}


