package se.su.dsv.scipro.reviewing;

import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.project.Project;

import javax.persistence.Entity;

@Entity
@SuppressWarnings("PMD.UnusedPrivateField")
public class FinalSeminarApproval extends ReviewerApproval {

    protected FinalSeminarApproval() {} // JPA

    public FinalSeminarApproval(final Project project, final FileDescription thesis, final String comment) {
        this.project = project;
        this.decisions.add(new Decision(this, thesis, comment));
    }

    @Override
    public Step getStep() {
        return Step.FINAL_SEMINAR_APPROVAL;
    }

    @Override
    protected int getDaysToDecide(final ReviewerDeadlineSettings reviewerDeadlineSettings) {
        return reviewerDeadlineSettings.getFinalSeminarApproval();
    }
}
