import com.googlecode.flyway.core.Flyway;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.sql.DataSource;

public class DatabaseMigration implements ServletContextListener {
    @Override
    public void contextInitialized(ServletContextEvent sce) {
        try {
            migrateDatabase();
        }
        catch(Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    private void migrateDatabase() throws NamingException {
        Flyway flyway = new Flyway();
        flyway.setDataSource(getDataSource());
        flyway.setInitOnMigrate(true);
        flyway.migrate();
    }

    private DataSource getDataSource() throws NamingException {
        return InitialContext.doLookup("java:comp/env/jdbc/defaultDS");
    }

    @Override
    public void contextDestroyed(ServletContextEvent sce) {
    }
}
