package se.su.dsv.scipro.basepages.errorpages;

import org.apache.wicket.behavior.AttributeAppender;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.protocol.http.BufferedWebResponse;
import org.apache.wicket.request.http.WebResponse;

import javax.servlet.http.HttpServletResponse;

/**
 * Fallback error page, used when all else fails.
 */
public class InternalErrorPage extends WebPage {
	public InternalErrorPage(){
		addErrorDetails();
	}
	@Override
	public boolean isVersioned() {
		return false;
	}
	@Override
	public boolean isErrorPage() {
		return true;
	}
	@Override
	protected void configureResponse(WebResponse webResponse) {
		super.configureResponse(webResponse);
        ((BufferedWebResponse)getResponse()).setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
	}
	private void addErrorDetails(){
		FeedbackPanel errorDetails = new FeedbackPanel("errorDetails");
		if (getApplication().usesDeploymentConfig()){
			errorDetails.add(new AttributeAppender("style", "display:none;"));
		}
		add(errorDetails);
	}
}
