package se.su.dsv.scipro.finalseminar;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.util.AjaxConfirmationLink;

import javax.inject.Inject;

public abstract class OpposeColumnPanel extends Panel {

    public static final String LINK = "link";
    public static final String OPPOSE_CONFIRMATION = "Are you sure you want to oppose on this seminar?";

    @Inject
    private FinalSeminarService finalSeminarService;

    private AjaxLink opposeLink;
    private OpposeColumnPanel opposeColumnPanel;

    public abstract void onClick(AjaxRequestTarget target, IModel<FinalSeminar> clickedModel);

    public OpposeColumnPanel(String id, final IModel<FinalSeminar> finalSeminarModel, final IModel<Project> projectModel) {
        super(id, finalSeminarModel);

        opposeColumnPanel = this;

        opposeLink = new AjaxConfirmationLink(LINK, OPPOSE_CONFIRMATION) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                opposeColumnPanel.onClick(target, finalSeminarModel);
                opposeLink.setEnabled(false);
                target.add(opposeLink);
            }

            @Override
            protected void onConfigure() {
                setEnabled(finalSeminarService.canOppose(SciProSession.get().getUser(), finalSeminarModel.getObject(), projectModel.getObject()));
            }
        };

        opposeLink.setOutputMarkupId(true);
        add(opposeLink);
    }
}
