package se.su.dsv.scipro.basepanels;

import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.FooterAddress;
import se.su.dsv.scipro.system.FooterColumn;
import se.su.dsv.scipro.system.FooterLink;

import java.util.Arrays;

import static org.mockito.Matchers.any;
import static org.mockito.Mockito.when;

public class FooterPanelTest extends SciProTest {

    @Before
    public void setUp() throws Exception {
        when(footerLinkService.getLinks(any(FooterColumn.class))).thenReturn(
                Arrays.asList(new FooterLink()));
    }

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    @Test
    public void shows_current_footer_address_if_available() throws Exception {
        FooterAddress address = mockExistingAddress();
        startPanel();
        tester.assertLabel(path("id", "address", "addresses", "title"), address.getTitle());
    }

    private FooterAddress mockExistingAddress() {
        FooterAddress address = new FooterAddress();
        address.setTitle("title!");
        address.setAddress("address 123");
        when(footerAddressRepo.findAll()).thenReturn(Arrays.asList(address));
        return address;
    }

    private FooterPanel startPanel() {
        return tester.startComponentInPage(new FooterPanel("id"));
    }
}
