package se.su.dsv.scipro.date;

import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mockito;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.security.auth.roles.Roles;

import static se.su.dsv.scipro.date.AdminDateSettingsPage.*;

@RunWith(MockitoJUnitRunner.class)
public class AdminDateSettingsPageTest extends SciProTest {

    @Before
    public void setUp() throws Exception {
        setLoggedIn(true);
        setRoles(Roles.SYSADMIN);
        tester.startPage(AdminDateSettingsPage.class);
    }

    @Test
    public void renders() throws Exception {
        tester.assertRenderedPage(AdminDateSettingsPage.class);
    }

    @Test
    public void submit_form_saves_formats() throws Exception {
        String format = "MM/dd/yy";

        FormTester formTester = tester.newFormTester(FORM);

        for (DateStyle dateStyle : DateStyle.values()) {
            formTester.setValue(path(SETTINGS, dateStyle.ordinal(), FORMAT), format);
        }

        formTester.submit();

        for (DateStyle dateStyle : DateStyle.values()) {
            Mockito.verify(dateService).saveFormat(format, dateStyle);
        }
    }
}
